git-stash.sh 6.5 KB
Newer Older
しらいしななこ 已提交
1 2 3
#!/bin/sh
# Copyright (c) 2007, Nanako Shiraishi

4 5
dashless=$(basename "$0" | sed -e 's/-/ /')
USAGE="list [<options>]
6 7
   or: $dashless ( show | drop ) [<stash>]
   or: $dashless ( pop | apply ) [--index] [<stash>]
8 9 10
   or: $dashless branch <branchname> [<stash>]
   or: $dashless [save [--keep-index] [<message>]]
   or: $dashless clear"
しらいしななこ 已提交
11

12
SUBDIRECTORY_OK=Yes
13
OPTIONS_SPEC=
しらいしななこ 已提交
14 15
. git-sh-setup
require_work_tree
16
cd_to_toplevel
しらいしななこ 已提交
17 18 19 20 21 22 23

TMP="$GIT_DIR/.git-stash.$$"
trap 'rm -f "$TMP-*"' 0

ref_stash=refs/stash

no_changes () {
24 25
	git diff-index --quiet --cached HEAD --ignore-submodules -- &&
	git diff-files --quiet --ignore-submodules
しらいしななこ 已提交
26 27 28
}

clear_stash () {
29 30 31 32
	if test $# != 0
	then
		die "git stash clear with parameters is unimplemented"
	fi
33
	if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
34
	then
E
Emil Medve 已提交
35
		git update-ref -d $ref_stash $current
36
	fi
しらいしななこ 已提交
37 38
}

J
Junio C Hamano 已提交
39
create_stash () {
40 41
	stash_msg="$1"

42
	git update-index -q --refresh
しらいしななこ 已提交
43 44 45 46
	if no_changes
	then
		exit 0
	fi
47

しらいしななこ 已提交
48
	# state of the base commit
49
	if b_commit=$(git rev-parse --verify HEAD)
しらいしななこ 已提交
50
	then
51
		head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
しらいしななこ 已提交
52 53 54 55
	else
		die "You do not have the initial commit yet"
	fi

56
	if branch=$(git symbolic-ref -q HEAD)
しらいしななこ 已提交
57 58 59 60 61 62 63 64
	then
		branch=${branch#refs/heads/}
	else
		branch='(no branch)'
	fi
	msg=$(printf '%s: %s' "$branch" "$head")

	# state of the index
65
	i_tree=$(git write-tree) &&
66
	i_commit=$(printf 'index on %s\n' "$msg" |
67
		git commit-tree $i_tree -p $b_commit) ||
しらいしななこ 已提交
68 69 70 71
		die "Cannot save the current index state"

	# state of the working tree
	w_tree=$( (
72 73
		rm -f "$TMP-index" &&
		cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
しらいしななこ 已提交
74 75
		GIT_INDEX_FILE="$TMP-index" &&
		export GIT_INDEX_FILE &&
76
		git read-tree -m $i_tree &&
77 78
		git add -u &&
		git write-tree &&
しらいしななこ 已提交
79 80 81 82 83
		rm -f "$TMP-index"
	) ) ||
		die "Cannot save the current worktree state"

	# create the stash
84 85 86 87 88 89 90
	if test -z "$stash_msg"
	then
		stash_msg=$(printf 'WIP on %s' "$msg")
	else
		stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
	fi
	w_commit=$(printf '%s\n' "$stash_msg" |
91
		git commit-tree $w_tree -p $b_commit -p $i_commit) ||
しらいしななこ 已提交
92
		die "Cannot record working tree state"
J
Junio C Hamano 已提交
93
}
しらいしななこ 已提交
94

J
Junio C Hamano 已提交
95
save_stash () {
96 97 98 99 100 101 102
	keep_index=
	case "$1" in
	--keep-index)
		keep_index=t
		shift
	esac

103
	stash_msg="$*"
J
Junio C Hamano 已提交
104

105
	git update-index -q --refresh
J
Junio C Hamano 已提交
106 107
	if no_changes
	then
108
		echo 'No local changes to save'
J
Junio C Hamano 已提交
109 110 111 112 113 114
		exit 0
	fi
	test -f "$GIT_DIR/logs/$ref_stash" ||
		clear_stash || die "Cannot initialize stash"

	create_stash "$stash_msg"
E
Emil Medve 已提交
115 116 117

	# Make sure the reflog for stash is kept.
	: >>"$GIT_DIR/logs/$ref_stash"
しらいしななこ 已提交
118

119
	git update-ref -m "$stash_msg" $ref_stash $w_commit ||
しらいしななこ 已提交
120
		die "Cannot save the current status"
121
	printf 'Saved working directory and index state "%s"\n' "$stash_msg"
122 123 124 125 126 127 128

	git reset --hard

	if test -n "$keep_index" && test -n $i_tree
	then
		git read-tree --reset -u $i_tree
	fi
しらいしななこ 已提交
129 130
}

131
have_stash () {
132
	git rev-parse --verify $ref_stash >/dev/null 2>&1
133 134
}

しらいしななこ 已提交
135
list_stash () {
136
	have_stash || return 0
137
	git log --no-color --pretty=oneline -g "$@" $ref_stash -- |
しらいしななこ 已提交
138 139 140 141
	sed -n -e 's/^[.0-9a-f]* refs\///p'
}

show_stash () {
142
	flags=$(git rev-parse --no-revs --flags "$@")
しらいしななこ 已提交
143 144 145 146
	if test -z "$flags"
	then
		flags=--stat
	fi
147

148 149
	w_commit=$(git rev-parse --verify --default $ref_stash "$@") &&
	b_commit=$(git rev-parse --verify "$w_commit^") &&
150
	git diff $flags $b_commit $w_commit
しらいしななこ 已提交
151 152 153
}

apply_stash () {
154
	git update-index -q --refresh &&
155
	git diff-files --quiet --ignore-submodules ||
156
		die 'Cannot apply to a dirty working tree, please stage your changes'
しらいしななこ 已提交
157

158 159 160 161 162 163 164
	unstash_index=
	case "$1" in
	--index)
		unstash_index=t
		shift
	esac

しらいしななこ 已提交
165
	# current index state
166
	c_tree=$(git write-tree) ||
しらいしななこ 已提交
167 168
		die 'Cannot apply a stash in the middle of a merge'

J
Junio C Hamano 已提交
169 170
	# stash records the work tree, and is a merge between the
	# base commit (first parent) and the index tree (second parent).
171
	s=$(git rev-parse --verify --default $ref_stash "$@") &&
172
	w_tree=$(git rev-parse --verify "$s:") &&
J
Junio C Hamano 已提交
173 174
	b_tree=$(git rev-parse --verify "$s^1:") &&
	i_tree=$(git rev-parse --verify "$s^2:") ||
しらいしななこ 已提交
175 176
		die "$*: no valid stashed state found"

J
Junio C Hamano 已提交
177
	unstashed_index_tree=
178 179
	if test -n "$unstash_index" && test "$b_tree" != "$i_tree" &&
			test "$c_tree" != "$i_tree"
J
Junio C Hamano 已提交
180
	then
181
		git diff-tree --binary $s^2^..$s^2 | git apply --cached
182 183 184 185 186
		test $? -ne 0 &&
			die 'Conflicts in index. Try without --index.'
		unstashed_index_tree=$(git-write-tree) ||
			die 'Could not save index tree'
		git reset
J
Junio C Hamano 已提交
187
	fi
188

しらいしななこ 已提交
189 190 191 192 193 194 195 196 197 198
	eval "
		GITHEAD_$w_tree='Stashed changes' &&
		GITHEAD_$c_tree='Updated upstream' &&
		GITHEAD_$b_tree='Version stash was based on' &&
		export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
	"

	if git-merge-recursive $b_tree -- $c_tree $w_tree
	then
		# No conflict
J
Junio C Hamano 已提交
199 200 201
		if test -n "$unstashed_index_tree"
		then
			git read-tree "$unstashed_index_tree"
202 203
		else
			a="$TMP-added" &&
204
			git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
205 206 207 208
			git read-tree --reset $c_tree &&
			git update-index --add --stdin <"$a" ||
				die "Cannot unstage modified files"
			rm -f "$a"
J
Junio C Hamano 已提交
209 210
		fi
		git status || :
しらいしななこ 已提交
211 212
	else
		# Merge conflict; keep the exit status from merge-recursive
213
		status=$?
J
Junio C Hamano 已提交
214 215 216 217
		if test -n "$unstash_index"
		then
			echo >&2 'Index was not unstashed.'
		fi
218
		exit $status
しらいしななこ 已提交
219 220 221
	fi
}

222 223 224 225 226 227 228 229 230
drop_stash () {
	have_stash || die 'No stash entries to drop'

	if test $# = 0
	then
		set x "$ref_stash@{0}"
		shift
	fi
	# Verify supplied argument looks like a stash entry
231
	s=$(git rev-parse --verify "$@") &&
232 233 234
	git rev-parse --verify "$s:"   > /dev/null 2>&1 &&
	git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
	git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
235 236 237 238 239 240
		die "$*: not a valid stashed state"

	git reflog delete --updateref --rewrite "$@" &&
		echo "Dropped $* ($s)" || die "$*: Could not drop stash entry"

	# clear_stash if we just dropped the last stash entry
241
	git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
242 243
}

244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260
apply_to_branch () {
	have_stash || die 'Nothing to apply'

	test -n "$1" || die 'No branch name specified'
	branch=$1

	if test -z "$2"
	then
		set x "$ref_stash@{0}"
	fi
	stash=$2

	git-checkout -b $branch $stash^ &&
	apply_stash --index $stash &&
	drop_stash $stash
}

しらいしななこ 已提交
261 262
# Main command set
case "$1" in
263 264
list)
	shift
しらいしななこ 已提交
265 266 267 268 269 270 271 272 273 274 275
	if test $# = 0
	then
		set x -n 10
		shift
	fi
	list_stash "$@"
	;;
show)
	shift
	show_stash "$@"
	;;
276 277
save)
	shift
278
	save_stash "$@"
279
	;;
しらいしななこ 已提交
280 281 282 283 284
apply)
	shift
	apply_stash "$@"
	;;
clear)
285 286
	shift
	clear_stash "$@"
しらいしななこ 已提交
287
	;;
J
Junio C Hamano 已提交
288 289 290 291 292 293 294
create)
	if test $# -gt 0 && test "$1" = create
	then
		shift
	fi
	create_stash "$*" && echo "$w_commit"
	;;
295 296 297 298
drop)
	shift
	drop_stash "$@"
	;;
299 300 301 302 303 304 305 306
pop)
	shift
	if apply_stash "$@"
	then
		test -z "$unstash_index" || shift
		drop_stash "$@"
	fi
	;;
307 308 309 310
branch)
	shift
	apply_to_branch "$@"
	;;
しらいしななこ 已提交
311
*)
312
	if test $# -eq 0
313
	then
314
		save_stash &&
315
		echo '(To restore them type "git stash apply")'
316 317
	else
		usage
318 319
	fi
	;;
しらいしななこ 已提交
320
esac